"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListEmptySection = void 0;
var react_1 = __importStar(require("react"));
var lodash_1 = require("lodash");
var ListEmptySection = function (props) {
    var entity = props.entity, search = props.search, tags = props.tags;
    var hasSearch = !(0, lodash_1.isNil)(search);
    var hasTags = (0, lodash_1.isArray)(tags) && tags.length > 0;
    var _a = (0, react_1.useState)(false), hasCategories = _a[0], setHasCategories = _a[1];
    (0, react_1.useEffect)(function () {
        setHasCategories(props.nodes && props.nodes.length > 0
            ? (0, lodash_1.filter)(props.nodes, function (node) {
                return node.entityName == "Category";
            }).length > 0
            : false);
    }, [props.nodes]);
    return (react_1.default.createElement("div", { className: "w-full p-4 flex flex-col" },
        react_1.default.createElement("span", { className: "text-base text-gray-700 pb-4" },
            "There is no ",
            entity.uiName,
            " returned from the query."),
        (hasSearch || hasTags || hasCategories) && (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("p", null,
                react_1.default.createElement("b", null, "Hope the tips below can help you.")),
            react_1.default.createElement("ul", null,
                hasSearch && (react_1.default.createElement("li", null, "* Check the spelling of your keyword")),
                hasTags && (react_1.default.createElement("li", null, "* Check the spelling of your tag(s)")),
                hasSearch && (react_1.default.createElement("li", null, "* Broaden your search by using fewer or more general word(s)")),
                hasTags && (react_1.default.createElement("li", null, "* Broaden your search by using fewer or more general tag(s)")),
                !hasCategories && (react_1.default.createElement("li", null, "* Select one or more categories to filter by categories")),
                !hasTags && (react_1.default.createElement("li", null, "* Select one or more tags to filter by tags")))))));
};
exports.ListEmptySection = ListEmptySection;
exports.default = exports.ListEmptySection;
//# sourceMappingURL=empty.js.map