//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState, useEffect } from "react";
import ListPageInternal from "./list";
import { getNavItem } from "../sections/nav/item";
import { getGlobalComponent } from "../util";
import { isSSR, getEntity } from "primeobjects-helper-util";
import { PageWrapper } from "./wrapper";
var ListPage = undefined;
export var ListPageWrapper = function (props) {
    var listViewMaxWidth = props.listViewMaxWidth, currentRecord = props.currentRecord, getForm = props.getForm, getList = props.getList, listChildren = props.listChildren, listAdjHeight = props.listAdjHeight, onResizeWrapper = props.onResizeWrapper, defaultRecordId = props.defaultRecordId, pageWrapperProps = __rest(props, ["listViewMaxWidth", "currentRecord", "getForm", "getList", "listChildren", "listAdjHeight", "onResizeWrapper", "defaultRecordId"]);
    var solution = props.solution, query = props.query, allowGuest = props.allowGuest;
    var _a = useState(undefined), context = _a[0], setContext = _a[1];
    var _b = useState(undefined), listInfo = _b[0], setListInfo = _b[1];
    var SSR = isSSR();
    var id = query.id;
    if (!SSR) {
        //because the nav router use shallow, we have to get it from window.location
        id = window.location.pathname.split("/");
        id = id[id.length - 1];
    }
    useEffect(function () {
        updateListInfo();
    }, [id, context]);
    var updateListInfo = function () {
        var _a, _b;
        var user = (_a = context === null || context === void 0 ? void 0 : context.user) !== null && _a !== void 0 ? _a : {};
        //because the nav router use shallow, we have to get it from window.location
        var navItem = getNavItem(solution.app.navigation, user, allowGuest);
        if (navItem) {
            var idInfo = id.split("_");
            var entityName = (_b = navItem === null || navItem === void 0 ? void 0 : navItem.entityName) !== null && _b !== void 0 ? _b : idInfo[0];
            var entityType = navItem.entityName
                ? navItem.entityType
                : idInfo.length > 1
                    ? idInfo[1]
                    : undefined;
            var entity = getEntity(solution, entityName, entityType);
            var list = getList(__assign(__assign({}, navItem), { entity: entity }), context);
            var form = getForm(__assign(__assign({}, navItem), entity), context);
            if (!list.sectionProps)
                list.sectionProps = {};
            if (!list.sectionProps.query)
                list.sectionProps.query = {};
            if (!list.sectionProps.query.entityName && entity)
                list.sectionProps.query.entityName = entity.entityName;
            if (!list.sectionProps.query.entityType && entity)
                list.sectionProps.query.entityType = entity.entityType;
            setListInfo(__assign(__assign({}, navItem), { entity: entity, list: list, form: form }));
        }
    };
    var onContextReady = function (newContext) {
        setContext(newContext);
        //put it here so we make sure the setGlobalComponent in the AppBasePage has been run
        if (!ListPage) {
            console.log("Get global components in /pages/list-wrapper.tsx");
            ListPage = getGlobalComponent("ListPage", ListPageInternal);
        }
        props.onContextReady && props.onContextReady(newContext);
    };
    var renderMainArea = function () {
        return ((listInfo === null || listInfo === void 0 ? void 0 : listInfo.entity) &&
            ListPage && (React.createElement(ListPage, __assign({}, props, { defaultRecordId: defaultRecordId, onResizeWrapper: props.onResizeWrapper, entity: listInfo.entity, Form: listInfo.form, view: listInfo.list.view ? listInfo.list.view : listInfo.view, apis: listInfo.list.sectionProps.apis, navOptions: listInfo.list.navOptions, listViewMaxWidth: listViewMaxWidth ? listViewMaxWidth : 950, listSectionProps: listInfo.list.sectionProps, onClickRecord: listInfo.list.onClickRecord, adjHeight: props.listAdjHeight ? props.listAdjHeight : 65 }), props.listChildren)));
    };
    return (React.createElement(PageWrapper, __assign({}, pageWrapperProps, { mainArea: renderMainArea(), onContextReady: onContextReady })));
};
export default ListPageWrapper;
//# sourceMappingURL=list-wrapper.js.map