//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import { PlainModal } from "primeobjects-ui-web-basic/build/cjs/controls/plain-modal";
import { getGlobalComponent } from "../../util";
import { useContextStore } from "primeobjects-ui-web-store";
import { getEntity } from "primeobjects-helper-util";
import { isNil } from "lodash";
var MeForm = undefined;
export var MeModal = function (props) {
    if (!MeForm) {
        console.log("Get global components in /modals/me-modal.tsx");
        MeForm = getGlobalComponent("MeForm", props.Form);
    }
    var contextStore = useContextStore();
    var context = JSON.parse(contextStore.data);
    var user = context.user, solution = context.solution;
    var entity = getEntity(solution, "User");
    var show = props.show, onClickClose = props.onClickClose, title = props.title;
    return (React.createElement(PlainModal, { title: title !== null && title !== void 0 ? title : "User Profile", show: show, onClickClose: onClickClose, width: 700 }, !isNil(MeForm) && React.createElement(MeForm, { entity: entity, record: user })));
};
export default MeModal;
//# sourceMappingURL=me-modal.js.map