//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import H1 from "primeobjects-ui-web-basic/build/cjs/controls/h1";
import H2 from "primeobjects-ui-web-basic/build/cjs/controls/h2";
import H3 from "primeobjects-ui-web-basic/build/cjs/controls/h3";
import H4 from "primeobjects-ui-web-basic/build/cjs/controls/h4";
import H5 from "primeobjects-ui-web-basic/build/cjs/controls/h5";
export var SiteTitle = function (props) {
    var _a;
    var title = props.title, subTitle = props.subTitle, titleSize = props.titleSize, subTitleSize = props.subTitleSize;
    var Title = React.createElement("h2");
    var SubTitle = React.createElement("h3");
    var titleClassName = props.titleClassName ? props.titleClassName : "";
    var subTitleClassName = props.subTitleClassName
        ? props.subTitleClassName
        : "";
    var titleStyle = (_a = props.titleStyle) !== null && _a !== void 0 ? _a : {};
    var subTitleStyle = props.subTitleStyle ? props.subTitleStyle : {};
    switch (titleSize) {
        case "h1": {
            titleClassName = "my-10 text-3xl sm:text-4xl ".concat(titleClassName);
            Title = H1;
            break;
        }
        case "h3": {
            titleClassName = "my-6 text-xl sm:text-2xl ".concat(titleClassName);
            Title = H3;
            break;
        }
        case "h4": {
            titleClassName = "my-4 text-lg sm:text-xl ".concat(titleClassName);
            Title = H4;
            break;
        }
        default: {
            titleClassName = "my-8 text-2xl sm:text-3xl ".concat(titleClassName);
            Title = H2;
            break;
        }
    }
    switch (subTitleSize) {
        case "h2": {
            subTitleClassName = "my-8 text-xl sm:text-2xl ".concat(subTitleClassName);
            SubTitle = H2;
            break;
        }
        case "h4": {
            subTitleClassName = "my-4 text-base sm:text-lg ".concat(subTitleClassName);
            SubTitle = H4;
            break;
        }
        case "h5": {
            subTitleClassName = "my-4 text-sm sm:text-base ".concat(subTitleClassName);
            SubTitle = H5;
            break;
        }
        default: {
            subTitleClassName = "my-10 text-lg sm:text-xl ".concat(subTitleClassName);
            SubTitle = H3;
            break;
        }
    }
    return isNonEmptyString(title) || isNonEmptyString(subTitle) ? (React.createElement(React.Fragment, null,
        isNonEmptyString(title) && (React.createElement(Title, { className: "font-bold tracking-tight ".concat(titleClassName, " ").concat(isNonEmptyString(subTitle) ? "mb-1" : ""), style: titleStyle }, title)),
        isNonEmptyString(subTitle) && (React.createElement(SubTitle, { className: "tracking-tight ".concat(subTitleClassName, " ").concat(isNonEmptyString(title) ? "mt-0" : ""), style: subTitleStyle }, subTitle)))) : (React.createElement(React.Fragment, null));
};
export default SiteTitle;
//# sourceMappingURL=site-title.js.map